pro create_diff_maps, dir0=dir0, file_visit1=file_visit1 $
  , read_fits=read_fits, nocov=nocov, dra=dra, ddec=ddec, flag=flag

;## SBNAF D2.1 version, 2016-09-30

if keyword_set(dra) then dx=dra else dx = (findgen(11)-5.)
if keyword_set(ddec) then dy=ddec else dy = (findgen(11)-5.)
if not keyword_set(flag) then flag = ''

if keyword_set(read_fits) then begin
 
  data1 = readfits(file_visit1,h1)
  im1 = data1(*,*,0)
  cov1 = data1(*,*,1)
  
endif else begin

  im1 = mrdfits(file_visit1,1,h1)
  cov1 = mrdfits(file_visit1,3)
  
endelse

ii = where(cov1 ge 0.6*max(cov1))
cov1(ii) = max(cov1)

;------------------

for i=0,n_elements(dx)-1 do begin
  for j=0,n_elements(dy)-1 do begin

    i_str = strcompress(string(i,format='(I)'),/remo)
    j_str = strcompress(string(j,format='(I)'),/remo)
    file_visit2_im = dir0 + '/' +'Visit2_im_'+i_str+'_'+j_str+'_crval.fits'
    file_visit2_cov = dir0 + '/' +'Visit2_cov_'+i_str+'_'+j_str+'_crval.fits'

    im2 = readfits(file_visit2_im, h2im)
    cov2 = readfits(file_visit2_cov, h2cov)
    
    hastrom, cov2, h2im, cov2m, h2m, h1
    hastrom, im2, h2im, im2m, h2m, h1
    
    ii=where(cov2m ge 0.6*max(cov2m))
    cov2m(ii) = max(cov2m)
    
    if keyword_set(nocov) then begin
   	    im_diff = im1-im2m
   	   ; flag = 'R31'
    endif else begin
        im_diff = (im1*cov1-im2m*cov2m)/(cov1+cov2m)
       ; flag = 'R3B'
    endelse
    
    writefits, dir0 + '/diff_im_' + i_str+'_'+j_str+'_'+flag+'.fits', im_diff, h1
    writefits, dir0 + '/diff_cov_' + i_str+'_'+j_str+'_'+flag+'.fits', (cov1+cov2m), h1

  endfor
endfor
    
end

