from herschel.all import *
from herschel.share.component import FileSelection
from herschel.pacs.spu import *
#
#dir1 = '/home/tno/TNO/LightCurves/Test_August4/'
#########################################################################
# This script provides the start and end FINETIMEs of all repetitions
# The results are saved into a FITS file
#########################################################################
def getRepetitionFineTimes(savefile):
    restore(savefile)
    rep_array = frames.getStatus('Repetition')
    ftime = frames.getStatus('FINETIME')
    rep_numbers = UNIQ(rep_array)
    nn = MAX(rep_numbers)+1
    start_times = Long1d(nn)
    end_times = Long1d(nn)
    for i in rep_numbers:
        ii = (rep_array == i)
        start_times[i] = MIN(ftime.get(ii))
        end_times[i] = MAX(ftime.get(ii))
##
    prod = Product()
    prod['RepetitionNumbers'] = ArrayDataset(rep_numbers)
    prod['StartTimes'] = ArrayDataset(start_times)
    prod['EndTimes'] = ArrayDataset(end_times)
    ff = FitsArchive()
    ff.save(savefile+'_repfinetimes.fits', prod)    
    print 'Repetitions: ', rep_numbers 
    print 'Number of reps. ', savefile, ' >> ', nn
##
