## Test script, Masked Map Center (MMC), 2011-June-13
## !! This is still not a cleaned version!! ##
## HPFWidth parameters correspond to the R3B, D and E versions (8,9,16)
## Min scan speed: 10 "/sec
## coeff_sourcemaskradius = [2, 1.5, 1.2] (versions B, D and E)
#######
from herschel.all import *
#from herschel.pacs.share.util import FileSelection
from herschel.share.component import FileSelection
#
login = "hcss.ia.pal.pool.hsa.haio.login_usr"
login_pwd = "hcss.ia.pal.pool.hsa.haio.login_pwd"
Configuration.setProperty(login, "ckiss")
Configuration.setProperty(login_pwd, "pa13joka")
#
obsids = Long1d([1342217348,1342217349,1342217351,1342217352\
		,1342230120,1342230121,1342230122,1342230123\
		,1342242770,1342242771,1342242772,1342242773\
		,1342252879,1342252880,1342252881,1342252882])
#
object_name = '_'
hipe_version='_'
scanSpeedLower = 10.0
scanSpeedUpper = 25.0
lowestScanNumber = 0
HPFCutLevel = 2.0
coeff_sourcemaskradius = 2.0
script_version=''
dir1 = '/w152/pkisscs/FaintStars/'
saveFileDir = dir1

from herschel.pacs.spu import *

### The loops are statting here.... --------->
##
for camera in ['blue','red']:
 for OBSID in obsids:
      SSSFlag = 1
      lowestScanNumber = 0
      print object_name, OBSID
##
      obs = getObservation(OBSID, useHsa = True)
#    calTree = getCalTree()
#
      if camera=='blue':
        frames=obs.level0.refs["HPPAVGB"].product.refs[0].product
      elif camera=='red':
        frames=obs.level0.refs["HPPAVGR"].product.refs[0].product
      print frames.signal.dimensions
#
      if (camera == 'blue'):
         if (frames.meta["blue"].getValue() == "blue1"):
           lam = 70.0
           filter="blue"
           pxsz = 1.1
           hpfwidth = 8
           fwhm = 5.6
         else:
           lam = 100.0
           filter="green"
           pxsz = 1.4
           hpfwidth = 9
           fwhm = 6.8
#
      if (camera == 'red'):
           lam = 160.0
           filter="red"
           pxsz = 2.1
           hpfwidth = 16
           fwhm = 11.3
#
      print '>>>>>> ', filter
#
      pp = obs.auxiliary.pointing
      print "Extracting OrbitEphemeris ..."
#   oep = obs.auxiliary.orbitEphemeris
      horizons = None
      hk = obs.level0.refs["HPPHK"].product.refs[0].product["HPPHKS"] 
#### starting the real processing
      calTree = getCalTree() 
#
      frames = findBlocks(frames, calTree=calTree)
      frames = detectCalibrationBlock(frames)
      frames = removeCalBlocks(frames,useBbid=1)
#
#      frames = removeCalBlocks(frames)
####
      frames = photFlagBadPixels(frames, calTree=calTree)
      badPix=frames.getMask("BADPIXELS") 
      badPix[:,0,:]=1
      badPix[:,16,:]=1
      if (camera == "blue"):
             badPix[:,32,:]=1
             badPix[:,48,:]=1
      frames.setMask("BADPIXELS",badPix)
#
####
# flag saturated pixels
#
      frames = photFlagSaturation(frames, calTree=calTree, hkdata=hk, check="full")
##
      frames = photConvDigit2Volts(frames, calTree=calTree)
#  
      frames = convertChopper2Angle(frames, calTree=calTree)
######################################################################
# MMTDeglitching was disabled and replaced 
#
#      frames = photMMTDeglitching(frames, incr_fact=2, mmt_mode='multiply'\
#         , scales=3, nsigma=5)
#
#-------------------------------------------
# Using FM-v6.0 responsivity calibration
#-------------------------------------------
    #  if FM6RespFlag == 1:
#      calDir = '/home/tno/TNO/CalFiles/'
#      pcal6 = fitsReader(calDir+"PCalPhotometer_Responsivity_FM_v6.fits")
#      frames = photRespFlatfieldCorrection(frames,calTree=calTree \
#          ,responsivity=pcal6)
#      resp_string = 'FM6Resp'
#
      frames = photRespFlatfieldCorrection(frames,calTree=calTree)
      resp_string = 'FM7Resp'
    #  else:
    #    frames = photRespFlatfieldCorrection(frames, calTree = calTree)
    #    resp_string = 'FM5Resp'
#
      frames = photAddInstantPointing(frames, pp, calTree=calTree)
#
      frames = photAssignRaDec(frames, calTree=calTree)
#
#############################################################
# Angular Velocity Computation 
# ALWAYS computed!
###########################################################
      if SSSFlag <= 1:
        AVX     = frames.getStatus("AngularVelocityX")
        AVY     = frames.getStatus("AngularVelocityY")
        AVZ     = frames.getStatus("AngularVelocityZ")
        n          = AVX.dimensions[0]
        AV       = Double2d(n,3)
        AV[:,0] = AVX*AVX
        AV[:,1] = AVY*AVY
        AV[:,2] = AVZ*AVZ
        AV_av = Int1d(n)
        AV_av = SQRT((AV[:,0]+AV[:,1]+AV[:,2]))
        ps         = frames.getStatusRef()
        ps.addDoubleParameter("ScanSpeed","",1)
        ps.setValues("ScanSpeed",AV_av)
        s = frames.getStatus("ScanLineNumber")   
#######################################################
# Passing all important parameters to the savefile
#######################################################
#
      frames.meta['HIPEVERSION']=StringParameter(hipe_version)
      frames.meta['FWHM'] = DoubleParameter(fwhm)
      frames.meta['SCANSPEEDLOWER'] = DoubleParameter(scanSpeedLower)
      frames.meta['SCANSPEEDUPPER'] = DoubleParameter(scanSpeedUpper)
      frames.meta['LOWESTSCANNUMBER'] = DoubleParameter(lowestScanNumber)
      frames.meta['COEFFSOURCEMASKRADIUS'] = \
                DoubleParameter(coeff_sourcemaskradius)
      frames.meta['PXSZ'] = DoubleParameter(pxsz)
      frames.meta['FILTER'] = StringParameter(filter)
      frames.meta['HPFWIDTH'] = LongParameter(hpfwidth)
      frames.meta['SSSFLAG'] = LongParameter(SSSFlag)
      frames.meta['OBSID'] = LongParameter(OBSID)
#
#######################################################
# Saving the "frames"
#######################################################
      savefile = saveFileDir+'/level1_frames_' + str(OBSID)\
                 + '_' + filter + '_' + script_version + '.sav'
      save(savefile,"frames")
      rep_array = frames.getStatus('Repetition')
      ftime = frames.getStatus('FINETIME')
      rep_numbers = UNIQ(rep_array)
      nn = MAX(rep_numbers)+1
      print 'Repetitions: ', rep_numbers 
      print 'Number of reps. ', nn
      System.gc()
#

