function noise_check_run, dir0=dir0, coverage=coverage, limits=limits, ps=ps $
  , dx=dx, dy=dy

if not keyword_set(limits) then limits=[0.5,0.85]

if not keyword_set(dx) then dx = (findgen(11)-5.)
if not keyword_set(dy) then dy = (findgen(11)-5.)
nx = n_elements(dx)
ny = n_elements(dy)

zz = fltarr(nx,ny)

for i=0,nx-1 do begin
  for j=0,ny-1 do begin
  
    i_str = strcompress(string(i,format='(I)'),/remo)
    j_str = strcompress(string(j,format='(I)'),/remo)
    
    filename_im = dir0 + 'diff_im_'+i_str+'_'+j_str+'.fits'
    filename_cov = dir0 + 'diff_cov_'+i_str+'_'+j_str+'.fits'
    
    print, filename_im
    im1 = readfits(filename_im,h)
    cov1 = mrdfits(filename_cov)
    cov1 = cov1/max(cov1)
          
    if keyword_set(coverage) then begin      
    
      ii = where(cov1 gt limits(0)*max(cov1) and cov1 lt limits(1)*max(cov1), cc)
      zz(i,j) = sigma(im1(ii))
      
    endif else begin
    
      n1 = fxpar(h,'NAXIS1')
      n2 = fxpar(h,'NAXIS2')
      dsize = 25
      im11 = im1(n1/2-dsize:n1/2+dsize, n2/2-dsize:n2/2+dsize)
      zz(i,j) = sigma(im11)
      
    endelse
    
  endfor
endfor

save, file = dir0+'noise_check_crval.sav', zz, dx, dy

if keyword_set(ps) then begin
  
  loadct, 4
  set_plot, 'ps'
  device, file=dir0+'noise_check_run.eps', xsize=20, ysize=20 $
     , /color, /encapsulated
  contour, zz, /fill, nlevels=30, xst=1, yst=1   
  device, /close 
  
  spawn, 'gv ' + dir0+'noise_check_crval.eps&'

endif

ii = where(zz eq min(zz))
aaa = array_indices(ii,zz)
return, [dx(aaa(0)), dy(aaa(1))]
   
end

;############

pro noise_check_run_2005uq513_red

 dir0_ = '2005uq513_optimized_red/'
 noise_check_run_crval, dir0=dir0_
 
end